package com.hai.entity;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class HighCouponAgentCodeExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    private Integer limit;

    private Long offset;

    public HighCouponAgentCodeExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    public void setLimit(Integer limit) {
        this.limit = limit;
    }

    public Integer getLimit() {
        return limit;
    }

    public void setOffset(Long offset) {
        this.offset = offset;
    }

    public Long getOffset() {
        return offset;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andTypeIsNull() {
            addCriterion("`type` is null");
            return (Criteria) this;
        }

        public Criteria andTypeIsNotNull() {
            addCriterion("`type` is not null");
            return (Criteria) this;
        }

        public Criteria andTypeEqualTo(Integer value) {
            addCriterion("`type` =", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeNotEqualTo(Integer value) {
            addCriterion("`type` <>", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeGreaterThan(Integer value) {
            addCriterion("`type` >", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeGreaterThanOrEqualTo(Integer value) {
            addCriterion("`type` >=", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeLessThan(Integer value) {
            addCriterion("`type` <", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeLessThanOrEqualTo(Integer value) {
            addCriterion("`type` <=", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeIn(List<Integer> values) {
            addCriterion("`type` in", values, "type");
            return (Criteria) this;
        }

        public Criteria andTypeNotIn(List<Integer> values) {
            addCriterion("`type` not in", values, "type");
            return (Criteria) this;
        }

        public Criteria andTypeBetween(Integer value1, Integer value2) {
            addCriterion("`type` between", value1, value2, "type");
            return (Criteria) this;
        }

        public Criteria andTypeNotBetween(Integer value1, Integer value2) {
            addCriterion("`type` not between", value1, value2, "type");
            return (Criteria) this;
        }

        public Criteria andCouponAgentIdIsNull() {
            addCriterion("coupon_agent_id is null");
            return (Criteria) this;
        }

        public Criteria andCouponAgentIdIsNotNull() {
            addCriterion("coupon_agent_id is not null");
            return (Criteria) this;
        }

        public Criteria andCouponAgentIdEqualTo(Long value) {
            addCriterion("coupon_agent_id =", value, "couponAgentId");
            return (Criteria) this;
        }

        public Criteria andCouponAgentIdNotEqualTo(Long value) {
            addCriterion("coupon_agent_id <>", value, "couponAgentId");
            return (Criteria) this;
        }

        public Criteria andCouponAgentIdGreaterThan(Long value) {
            addCriterion("coupon_agent_id >", value, "couponAgentId");
            return (Criteria) this;
        }

        public Criteria andCouponAgentIdGreaterThanOrEqualTo(Long value) {
            addCriterion("coupon_agent_id >=", value, "couponAgentId");
            return (Criteria) this;
        }

        public Criteria andCouponAgentIdLessThan(Long value) {
            addCriterion("coupon_agent_id <", value, "couponAgentId");
            return (Criteria) this;
        }

        public Criteria andCouponAgentIdLessThanOrEqualTo(Long value) {
            addCriterion("coupon_agent_id <=", value, "couponAgentId");
            return (Criteria) this;
        }

        public Criteria andCouponAgentIdIn(List<Long> values) {
            addCriterion("coupon_agent_id in", values, "couponAgentId");
            return (Criteria) this;
        }

        public Criteria andCouponAgentIdNotIn(List<Long> values) {
            addCriterion("coupon_agent_id not in", values, "couponAgentId");
            return (Criteria) this;
        }

        public Criteria andCouponAgentIdBetween(Long value1, Long value2) {
            addCriterion("coupon_agent_id between", value1, value2, "couponAgentId");
            return (Criteria) this;
        }

        public Criteria andCouponAgentIdNotBetween(Long value1, Long value2) {
            addCriterion("coupon_agent_id not between", value1, value2, "couponAgentId");
            return (Criteria) this;
        }

        public Criteria andCouponIdIsNull() {
            addCriterion("coupon_id is null");
            return (Criteria) this;
        }

        public Criteria andCouponIdIsNotNull() {
            addCriterion("coupon_id is not null");
            return (Criteria) this;
        }

        public Criteria andCouponIdEqualTo(Long value) {
            addCriterion("coupon_id =", value, "couponId");
            return (Criteria) this;
        }

        public Criteria andCouponIdNotEqualTo(Long value) {
            addCriterion("coupon_id <>", value, "couponId");
            return (Criteria) this;
        }

        public Criteria andCouponIdGreaterThan(Long value) {
            addCriterion("coupon_id >", value, "couponId");
            return (Criteria) this;
        }

        public Criteria andCouponIdGreaterThanOrEqualTo(Long value) {
            addCriterion("coupon_id >=", value, "couponId");
            return (Criteria) this;
        }

        public Criteria andCouponIdLessThan(Long value) {
            addCriterion("coupon_id <", value, "couponId");
            return (Criteria) this;
        }

        public Criteria andCouponIdLessThanOrEqualTo(Long value) {
            addCriterion("coupon_id <=", value, "couponId");
            return (Criteria) this;
        }

        public Criteria andCouponIdIn(List<Long> values) {
            addCriterion("coupon_id in", values, "couponId");
            return (Criteria) this;
        }

        public Criteria andCouponIdNotIn(List<Long> values) {
            addCriterion("coupon_id not in", values, "couponId");
            return (Criteria) this;
        }

        public Criteria andCouponIdBetween(Long value1, Long value2) {
            addCriterion("coupon_id between", value1, value2, "couponId");
            return (Criteria) this;
        }

        public Criteria andCouponIdNotBetween(Long value1, Long value2) {
            addCriterion("coupon_id not between", value1, value2, "couponId");
            return (Criteria) this;
        }

        public Criteria andAgentIdIsNull() {
            addCriterion("agent_id is null");
            return (Criteria) this;
        }

        public Criteria andAgentIdIsNotNull() {
            addCriterion("agent_id is not null");
            return (Criteria) this;
        }

        public Criteria andAgentIdEqualTo(Long value) {
            addCriterion("agent_id =", value, "agentId");
            return (Criteria) this;
        }

        public Criteria andAgentIdNotEqualTo(Long value) {
            addCriterion("agent_id <>", value, "agentId");
            return (Criteria) this;
        }

        public Criteria andAgentIdGreaterThan(Long value) {
            addCriterion("agent_id >", value, "agentId");
            return (Criteria) this;
        }

        public Criteria andAgentIdGreaterThanOrEqualTo(Long value) {
            addCriterion("agent_id >=", value, "agentId");
            return (Criteria) this;
        }

        public Criteria andAgentIdLessThan(Long value) {
            addCriterion("agent_id <", value, "agentId");
            return (Criteria) this;
        }

        public Criteria andAgentIdLessThanOrEqualTo(Long value) {
            addCriterion("agent_id <=", value, "agentId");
            return (Criteria) this;
        }

        public Criteria andAgentIdIn(List<Long> values) {
            addCriterion("agent_id in", values, "agentId");
            return (Criteria) this;
        }

        public Criteria andAgentIdNotIn(List<Long> values) {
            addCriterion("agent_id not in", values, "agentId");
            return (Criteria) this;
        }

        public Criteria andAgentIdBetween(Long value1, Long value2) {
            addCriterion("agent_id between", value1, value2, "agentId");
            return (Criteria) this;
        }

        public Criteria andAgentIdNotBetween(Long value1, Long value2) {
            addCriterion("agent_id not between", value1, value2, "agentId");
            return (Criteria) this;
        }

        public Criteria andCouponAgentRecordIdIsNull() {
            addCriterion("coupon_agent_record_id is null");
            return (Criteria) this;
        }

        public Criteria andCouponAgentRecordIdIsNotNull() {
            addCriterion("coupon_agent_record_id is not null");
            return (Criteria) this;
        }

        public Criteria andCouponAgentRecordIdEqualTo(Long value) {
            addCriterion("coupon_agent_record_id =", value, "couponAgentRecordId");
            return (Criteria) this;
        }

        public Criteria andCouponAgentRecordIdNotEqualTo(Long value) {
            addCriterion("coupon_agent_record_id <>", value, "couponAgentRecordId");
            return (Criteria) this;
        }

        public Criteria andCouponAgentRecordIdGreaterThan(Long value) {
            addCriterion("coupon_agent_record_id >", value, "couponAgentRecordId");
            return (Criteria) this;
        }

        public Criteria andCouponAgentRecordIdGreaterThanOrEqualTo(Long value) {
            addCriterion("coupon_agent_record_id >=", value, "couponAgentRecordId");
            return (Criteria) this;
        }

        public Criteria andCouponAgentRecordIdLessThan(Long value) {
            addCriterion("coupon_agent_record_id <", value, "couponAgentRecordId");
            return (Criteria) this;
        }

        public Criteria andCouponAgentRecordIdLessThanOrEqualTo(Long value) {
            addCriterion("coupon_agent_record_id <=", value, "couponAgentRecordId");
            return (Criteria) this;
        }

        public Criteria andCouponAgentRecordIdIn(List<Long> values) {
            addCriterion("coupon_agent_record_id in", values, "couponAgentRecordId");
            return (Criteria) this;
        }

        public Criteria andCouponAgentRecordIdNotIn(List<Long> values) {
            addCriterion("coupon_agent_record_id not in", values, "couponAgentRecordId");
            return (Criteria) this;
        }

        public Criteria andCouponAgentRecordIdBetween(Long value1, Long value2) {
            addCriterion("coupon_agent_record_id between", value1, value2, "couponAgentRecordId");
            return (Criteria) this;
        }

        public Criteria andCouponAgentRecordIdNotBetween(Long value1, Long value2) {
            addCriterion("coupon_agent_record_id not between", value1, value2, "couponAgentRecordId");
            return (Criteria) this;
        }

        public Criteria andConvertUserPhoneIsNull() {
            addCriterion("convert_user_phone is null");
            return (Criteria) this;
        }

        public Criteria andConvertUserPhoneIsNotNull() {
            addCriterion("convert_user_phone is not null");
            return (Criteria) this;
        }

        public Criteria andConvertUserPhoneEqualTo(String value) {
            addCriterion("convert_user_phone =", value, "convertUserPhone");
            return (Criteria) this;
        }

        public Criteria andConvertUserPhoneNotEqualTo(String value) {
            addCriterion("convert_user_phone <>", value, "convertUserPhone");
            return (Criteria) this;
        }

        public Criteria andConvertUserPhoneGreaterThan(String value) {
            addCriterion("convert_user_phone >", value, "convertUserPhone");
            return (Criteria) this;
        }

        public Criteria andConvertUserPhoneGreaterThanOrEqualTo(String value) {
            addCriterion("convert_user_phone >=", value, "convertUserPhone");
            return (Criteria) this;
        }

        public Criteria andConvertUserPhoneLessThan(String value) {
            addCriterion("convert_user_phone <", value, "convertUserPhone");
            return (Criteria) this;
        }

        public Criteria andConvertUserPhoneLessThanOrEqualTo(String value) {
            addCriterion("convert_user_phone <=", value, "convertUserPhone");
            return (Criteria) this;
        }

        public Criteria andConvertUserPhoneLike(String value) {
            addCriterion("convert_user_phone like", value, "convertUserPhone");
            return (Criteria) this;
        }

        public Criteria andConvertUserPhoneNotLike(String value) {
            addCriterion("convert_user_phone not like", value, "convertUserPhone");
            return (Criteria) this;
        }

        public Criteria andConvertUserPhoneIn(List<String> values) {
            addCriterion("convert_user_phone in", values, "convertUserPhone");
            return (Criteria) this;
        }

        public Criteria andConvertUserPhoneNotIn(List<String> values) {
            addCriterion("convert_user_phone not in", values, "convertUserPhone");
            return (Criteria) this;
        }

        public Criteria andConvertUserPhoneBetween(String value1, String value2) {
            addCriterion("convert_user_phone between", value1, value2, "convertUserPhone");
            return (Criteria) this;
        }

        public Criteria andConvertUserPhoneNotBetween(String value1, String value2) {
            addCriterion("convert_user_phone not between", value1, value2, "convertUserPhone");
            return (Criteria) this;
        }

        public Criteria andConvertCodeIsNull() {
            addCriterion("convert_code is null");
            return (Criteria) this;
        }

        public Criteria andConvertCodeIsNotNull() {
            addCriterion("convert_code is not null");
            return (Criteria) this;
        }

        public Criteria andConvertCodeEqualTo(String value) {
            addCriterion("convert_code =", value, "convertCode");
            return (Criteria) this;
        }

        public Criteria andConvertCodeNotEqualTo(String value) {
            addCriterion("convert_code <>", value, "convertCode");
            return (Criteria) this;
        }

        public Criteria andConvertCodeGreaterThan(String value) {
            addCriterion("convert_code >", value, "convertCode");
            return (Criteria) this;
        }

        public Criteria andConvertCodeGreaterThanOrEqualTo(String value) {
            addCriterion("convert_code >=", value, "convertCode");
            return (Criteria) this;
        }

        public Criteria andConvertCodeLessThan(String value) {
            addCriterion("convert_code <", value, "convertCode");
            return (Criteria) this;
        }

        public Criteria andConvertCodeLessThanOrEqualTo(String value) {
            addCriterion("convert_code <=", value, "convertCode");
            return (Criteria) this;
        }

        public Criteria andConvertCodeLike(String value) {
            addCriterion("convert_code like", value, "convertCode");
            return (Criteria) this;
        }

        public Criteria andConvertCodeNotLike(String value) {
            addCriterion("convert_code not like", value, "convertCode");
            return (Criteria) this;
        }

        public Criteria andConvertCodeIn(List<String> values) {
            addCriterion("convert_code in", values, "convertCode");
            return (Criteria) this;
        }

        public Criteria andConvertCodeNotIn(List<String> values) {
            addCriterion("convert_code not in", values, "convertCode");
            return (Criteria) this;
        }

        public Criteria andConvertCodeBetween(String value1, String value2) {
            addCriterion("convert_code between", value1, value2, "convertCode");
            return (Criteria) this;
        }

        public Criteria andConvertCodeNotBetween(String value1, String value2) {
            addCriterion("convert_code not between", value1, value2, "convertCode");
            return (Criteria) this;
        }

        public Criteria andCouponCodeIdIsNull() {
            addCriterion("coupon_code_id is null");
            return (Criteria) this;
        }

        public Criteria andCouponCodeIdIsNotNull() {
            addCriterion("coupon_code_id is not null");
            return (Criteria) this;
        }

        public Criteria andCouponCodeIdEqualTo(Long value) {
            addCriterion("coupon_code_id =", value, "couponCodeId");
            return (Criteria) this;
        }

        public Criteria andCouponCodeIdNotEqualTo(Long value) {
            addCriterion("coupon_code_id <>", value, "couponCodeId");
            return (Criteria) this;
        }

        public Criteria andCouponCodeIdGreaterThan(Long value) {
            addCriterion("coupon_code_id >", value, "couponCodeId");
            return (Criteria) this;
        }

        public Criteria andCouponCodeIdGreaterThanOrEqualTo(Long value) {
            addCriterion("coupon_code_id >=", value, "couponCodeId");
            return (Criteria) this;
        }

        public Criteria andCouponCodeIdLessThan(Long value) {
            addCriterion("coupon_code_id <", value, "couponCodeId");
            return (Criteria) this;
        }

        public Criteria andCouponCodeIdLessThanOrEqualTo(Long value) {
            addCriterion("coupon_code_id <=", value, "couponCodeId");
            return (Criteria) this;
        }

        public Criteria andCouponCodeIdIn(List<Long> values) {
            addCriterion("coupon_code_id in", values, "couponCodeId");
            return (Criteria) this;
        }

        public Criteria andCouponCodeIdNotIn(List<Long> values) {
            addCriterion("coupon_code_id not in", values, "couponCodeId");
            return (Criteria) this;
        }

        public Criteria andCouponCodeIdBetween(Long value1, Long value2) {
            addCriterion("coupon_code_id between", value1, value2, "couponCodeId");
            return (Criteria) this;
        }

        public Criteria andCouponCodeIdNotBetween(Long value1, Long value2) {
            addCriterion("coupon_code_id not between", value1, value2, "couponCodeId");
            return (Criteria) this;
        }

        public Criteria andCouponCodeIsNull() {
            addCriterion("coupon_code is null");
            return (Criteria) this;
        }

        public Criteria andCouponCodeIsNotNull() {
            addCriterion("coupon_code is not null");
            return (Criteria) this;
        }

        public Criteria andCouponCodeEqualTo(String value) {
            addCriterion("coupon_code =", value, "couponCode");
            return (Criteria) this;
        }

        public Criteria andCouponCodeNotEqualTo(String value) {
            addCriterion("coupon_code <>", value, "couponCode");
            return (Criteria) this;
        }

        public Criteria andCouponCodeGreaterThan(String value) {
            addCriterion("coupon_code >", value, "couponCode");
            return (Criteria) this;
        }

        public Criteria andCouponCodeGreaterThanOrEqualTo(String value) {
            addCriterion("coupon_code >=", value, "couponCode");
            return (Criteria) this;
        }

        public Criteria andCouponCodeLessThan(String value) {
            addCriterion("coupon_code <", value, "couponCode");
            return (Criteria) this;
        }

        public Criteria andCouponCodeLessThanOrEqualTo(String value) {
            addCriterion("coupon_code <=", value, "couponCode");
            return (Criteria) this;
        }

        public Criteria andCouponCodeLike(String value) {
            addCriterion("coupon_code like", value, "couponCode");
            return (Criteria) this;
        }

        public Criteria andCouponCodeNotLike(String value) {
            addCriterion("coupon_code not like", value, "couponCode");
            return (Criteria) this;
        }

        public Criteria andCouponCodeIn(List<String> values) {
            addCriterion("coupon_code in", values, "couponCode");
            return (Criteria) this;
        }

        public Criteria andCouponCodeNotIn(List<String> values) {
            addCriterion("coupon_code not in", values, "couponCode");
            return (Criteria) this;
        }

        public Criteria andCouponCodeBetween(String value1, String value2) {
            addCriterion("coupon_code between", value1, value2, "couponCode");
            return (Criteria) this;
        }

        public Criteria andCouponCodeNotBetween(String value1, String value2) {
            addCriterion("coupon_code not between", value1, value2, "couponCode");
            return (Criteria) this;
        }

        public Criteria andQrCodeIsNull() {
            addCriterion("qr_code is null");
            return (Criteria) this;
        }

        public Criteria andQrCodeIsNotNull() {
            addCriterion("qr_code is not null");
            return (Criteria) this;
        }

        public Criteria andQrCodeEqualTo(String value) {
            addCriterion("qr_code =", value, "qrCode");
            return (Criteria) this;
        }

        public Criteria andQrCodeNotEqualTo(String value) {
            addCriterion("qr_code <>", value, "qrCode");
            return (Criteria) this;
        }

        public Criteria andQrCodeGreaterThan(String value) {
            addCriterion("qr_code >", value, "qrCode");
            return (Criteria) this;
        }

        public Criteria andQrCodeGreaterThanOrEqualTo(String value) {
            addCriterion("qr_code >=", value, "qrCode");
            return (Criteria) this;
        }

        public Criteria andQrCodeLessThan(String value) {
            addCriterion("qr_code <", value, "qrCode");
            return (Criteria) this;
        }

        public Criteria andQrCodeLessThanOrEqualTo(String value) {
            addCriterion("qr_code <=", value, "qrCode");
            return (Criteria) this;
        }

        public Criteria andQrCodeLike(String value) {
            addCriterion("qr_code like", value, "qrCode");
            return (Criteria) this;
        }

        public Criteria andQrCodeNotLike(String value) {
            addCriterion("qr_code not like", value, "qrCode");
            return (Criteria) this;
        }

        public Criteria andQrCodeIn(List<String> values) {
            addCriterion("qr_code in", values, "qrCode");
            return (Criteria) this;
        }

        public Criteria andQrCodeNotIn(List<String> values) {
            addCriterion("qr_code not in", values, "qrCode");
            return (Criteria) this;
        }

        public Criteria andQrCodeBetween(String value1, String value2) {
            addCriterion("qr_code between", value1, value2, "qrCode");
            return (Criteria) this;
        }

        public Criteria andQrCodeNotBetween(String value1, String value2) {
            addCriterion("qr_code not between", value1, value2, "qrCode");
            return (Criteria) this;
        }

        public Criteria andStatusIsNull() {
            addCriterion("`status` is null");
            return (Criteria) this;
        }

        public Criteria andStatusIsNotNull() {
            addCriterion("`status` is not null");
            return (Criteria) this;
        }

        public Criteria andStatusEqualTo(Integer value) {
            addCriterion("`status` =", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotEqualTo(Integer value) {
            addCriterion("`status` <>", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusGreaterThan(Integer value) {
            addCriterion("`status` >", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusGreaterThanOrEqualTo(Integer value) {
            addCriterion("`status` >=", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusLessThan(Integer value) {
            addCriterion("`status` <", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusLessThanOrEqualTo(Integer value) {
            addCriterion("`status` <=", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusIn(List<Integer> values) {
            addCriterion("`status` in", values, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotIn(List<Integer> values) {
            addCriterion("`status` not in", values, "status");
            return (Criteria) this;
        }

        public Criteria andStatusBetween(Integer value1, Integer value2) {
            addCriterion("`status` between", value1, value2, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotBetween(Integer value1, Integer value2) {
            addCriterion("`status` not between", value1, value2, "status");
            return (Criteria) this;
        }

        public Criteria andAssignCouponAgentIdIsNull() {
            addCriterion("assign_coupon_agent_id is null");
            return (Criteria) this;
        }

        public Criteria andAssignCouponAgentIdIsNotNull() {
            addCriterion("assign_coupon_agent_id is not null");
            return (Criteria) this;
        }

        public Criteria andAssignCouponAgentIdEqualTo(Long value) {
            addCriterion("assign_coupon_agent_id =", value, "assignCouponAgentId");
            return (Criteria) this;
        }

        public Criteria andAssignCouponAgentIdNotEqualTo(Long value) {
            addCriterion("assign_coupon_agent_id <>", value, "assignCouponAgentId");
            return (Criteria) this;
        }

        public Criteria andAssignCouponAgentIdGreaterThan(Long value) {
            addCriterion("assign_coupon_agent_id >", value, "assignCouponAgentId");
            return (Criteria) this;
        }

        public Criteria andAssignCouponAgentIdGreaterThanOrEqualTo(Long value) {
            addCriterion("assign_coupon_agent_id >=", value, "assignCouponAgentId");
            return (Criteria) this;
        }

        public Criteria andAssignCouponAgentIdLessThan(Long value) {
            addCriterion("assign_coupon_agent_id <", value, "assignCouponAgentId");
            return (Criteria) this;
        }

        public Criteria andAssignCouponAgentIdLessThanOrEqualTo(Long value) {
            addCriterion("assign_coupon_agent_id <=", value, "assignCouponAgentId");
            return (Criteria) this;
        }

        public Criteria andAssignCouponAgentIdIn(List<Long> values) {
            addCriterion("assign_coupon_agent_id in", values, "assignCouponAgentId");
            return (Criteria) this;
        }

        public Criteria andAssignCouponAgentIdNotIn(List<Long> values) {
            addCriterion("assign_coupon_agent_id not in", values, "assignCouponAgentId");
            return (Criteria) this;
        }

        public Criteria andAssignCouponAgentIdBetween(Long value1, Long value2) {
            addCriterion("assign_coupon_agent_id between", value1, value2, "assignCouponAgentId");
            return (Criteria) this;
        }

        public Criteria andAssignCouponAgentIdNotBetween(Long value1, Long value2) {
            addCriterion("assign_coupon_agent_id not between", value1, value2, "assignCouponAgentId");
            return (Criteria) this;
        }

        public Criteria andAssignAgentIdIsNull() {
            addCriterion("assign_agent_id is null");
            return (Criteria) this;
        }

        public Criteria andAssignAgentIdIsNotNull() {
            addCriterion("assign_agent_id is not null");
            return (Criteria) this;
        }

        public Criteria andAssignAgentIdEqualTo(Long value) {
            addCriterion("assign_agent_id =", value, "assignAgentId");
            return (Criteria) this;
        }

        public Criteria andAssignAgentIdNotEqualTo(Long value) {
            addCriterion("assign_agent_id <>", value, "assignAgentId");
            return (Criteria) this;
        }

        public Criteria andAssignAgentIdGreaterThan(Long value) {
            addCriterion("assign_agent_id >", value, "assignAgentId");
            return (Criteria) this;
        }

        public Criteria andAssignAgentIdGreaterThanOrEqualTo(Long value) {
            addCriterion("assign_agent_id >=", value, "assignAgentId");
            return (Criteria) this;
        }

        public Criteria andAssignAgentIdLessThan(Long value) {
            addCriterion("assign_agent_id <", value, "assignAgentId");
            return (Criteria) this;
        }

        public Criteria andAssignAgentIdLessThanOrEqualTo(Long value) {
            addCriterion("assign_agent_id <=", value, "assignAgentId");
            return (Criteria) this;
        }

        public Criteria andAssignAgentIdIn(List<Long> values) {
            addCriterion("assign_agent_id in", values, "assignAgentId");
            return (Criteria) this;
        }

        public Criteria andAssignAgentIdNotIn(List<Long> values) {
            addCriterion("assign_agent_id not in", values, "assignAgentId");
            return (Criteria) this;
        }

        public Criteria andAssignAgentIdBetween(Long value1, Long value2) {
            addCriterion("assign_agent_id between", value1, value2, "assignAgentId");
            return (Criteria) this;
        }

        public Criteria andAssignAgentIdNotBetween(Long value1, Long value2) {
            addCriterion("assign_agent_id not between", value1, value2, "assignAgentId");
            return (Criteria) this;
        }

        public Criteria andAssignAgentNameIsNull() {
            addCriterion("assign_agent_name is null");
            return (Criteria) this;
        }

        public Criteria andAssignAgentNameIsNotNull() {
            addCriterion("assign_agent_name is not null");
            return (Criteria) this;
        }

        public Criteria andAssignAgentNameEqualTo(String value) {
            addCriterion("assign_agent_name =", value, "assignAgentName");
            return (Criteria) this;
        }

        public Criteria andAssignAgentNameNotEqualTo(String value) {
            addCriterion("assign_agent_name <>", value, "assignAgentName");
            return (Criteria) this;
        }

        public Criteria andAssignAgentNameGreaterThan(String value) {
            addCriterion("assign_agent_name >", value, "assignAgentName");
            return (Criteria) this;
        }

        public Criteria andAssignAgentNameGreaterThanOrEqualTo(String value) {
            addCriterion("assign_agent_name >=", value, "assignAgentName");
            return (Criteria) this;
        }

        public Criteria andAssignAgentNameLessThan(String value) {
            addCriterion("assign_agent_name <", value, "assignAgentName");
            return (Criteria) this;
        }

        public Criteria andAssignAgentNameLessThanOrEqualTo(String value) {
            addCriterion("assign_agent_name <=", value, "assignAgentName");
            return (Criteria) this;
        }

        public Criteria andAssignAgentNameLike(String value) {
            addCriterion("assign_agent_name like", value, "assignAgentName");
            return (Criteria) this;
        }

        public Criteria andAssignAgentNameNotLike(String value) {
            addCriterion("assign_agent_name not like", value, "assignAgentName");
            return (Criteria) this;
        }

        public Criteria andAssignAgentNameIn(List<String> values) {
            addCriterion("assign_agent_name in", values, "assignAgentName");
            return (Criteria) this;
        }

        public Criteria andAssignAgentNameNotIn(List<String> values) {
            addCriterion("assign_agent_name not in", values, "assignAgentName");
            return (Criteria) this;
        }

        public Criteria andAssignAgentNameBetween(String value1, String value2) {
            addCriterion("assign_agent_name between", value1, value2, "assignAgentName");
            return (Criteria) this;
        }

        public Criteria andAssignAgentNameNotBetween(String value1, String value2) {
            addCriterion("assign_agent_name not between", value1, value2, "assignAgentName");
            return (Criteria) this;
        }

        public Criteria andRemarkIsNull() {
            addCriterion("remark is null");
            return (Criteria) this;
        }

        public Criteria andRemarkIsNotNull() {
            addCriterion("remark is not null");
            return (Criteria) this;
        }

        public Criteria andRemarkEqualTo(String value) {
            addCriterion("remark =", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotEqualTo(String value) {
            addCriterion("remark <>", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkGreaterThan(String value) {
            addCriterion("remark >", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkGreaterThanOrEqualTo(String value) {
            addCriterion("remark >=", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLessThan(String value) {
            addCriterion("remark <", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLessThanOrEqualTo(String value) {
            addCriterion("remark <=", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLike(String value) {
            addCriterion("remark like", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotLike(String value) {
            addCriterion("remark not like", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkIn(List<String> values) {
            addCriterion("remark in", values, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotIn(List<String> values) {
            addCriterion("remark not in", values, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkBetween(String value1, String value2) {
            addCriterion("remark between", value1, value2, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotBetween(String value1, String value2) {
            addCriterion("remark not between", value1, value2, "remark");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("create_time is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("create_time is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("create_time =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("create_time <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("create_time >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("create_time >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("create_time <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("create_time <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("create_time in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("create_time not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("create_time between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("create_time not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andSalesTimeIsNull() {
            addCriterion("sales_time is null");
            return (Criteria) this;
        }

        public Criteria andSalesTimeIsNotNull() {
            addCriterion("sales_time is not null");
            return (Criteria) this;
        }

        public Criteria andSalesTimeEqualTo(Date value) {
            addCriterion("sales_time =", value, "salesTime");
            return (Criteria) this;
        }

        public Criteria andSalesTimeNotEqualTo(Date value) {
            addCriterion("sales_time <>", value, "salesTime");
            return (Criteria) this;
        }

        public Criteria andSalesTimeGreaterThan(Date value) {
            addCriterion("sales_time >", value, "salesTime");
            return (Criteria) this;
        }

        public Criteria andSalesTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("sales_time >=", value, "salesTime");
            return (Criteria) this;
        }

        public Criteria andSalesTimeLessThan(Date value) {
            addCriterion("sales_time <", value, "salesTime");
            return (Criteria) this;
        }

        public Criteria andSalesTimeLessThanOrEqualTo(Date value) {
            addCriterion("sales_time <=", value, "salesTime");
            return (Criteria) this;
        }

        public Criteria andSalesTimeIn(List<Date> values) {
            addCriterion("sales_time in", values, "salesTime");
            return (Criteria) this;
        }

        public Criteria andSalesTimeNotIn(List<Date> values) {
            addCriterion("sales_time not in", values, "salesTime");
            return (Criteria) this;
        }

        public Criteria andSalesTimeBetween(Date value1, Date value2) {
            addCriterion("sales_time between", value1, value2, "salesTime");
            return (Criteria) this;
        }

        public Criteria andSalesTimeNotBetween(Date value1, Date value2) {
            addCriterion("sales_time not between", value1, value2, "salesTime");
            return (Criteria) this;
        }

        public Criteria andOperatorIdIsNull() {
            addCriterion("operator_id is null");
            return (Criteria) this;
        }

        public Criteria andOperatorIdIsNotNull() {
            addCriterion("operator_id is not null");
            return (Criteria) this;
        }

        public Criteria andOperatorIdEqualTo(Long value) {
            addCriterion("operator_id =", value, "operatorId");
            return (Criteria) this;
        }

        public Criteria andOperatorIdNotEqualTo(Long value) {
            addCriterion("operator_id <>", value, "operatorId");
            return (Criteria) this;
        }

        public Criteria andOperatorIdGreaterThan(Long value) {
            addCriterion("operator_id >", value, "operatorId");
            return (Criteria) this;
        }

        public Criteria andOperatorIdGreaterThanOrEqualTo(Long value) {
            addCriterion("operator_id >=", value, "operatorId");
            return (Criteria) this;
        }

        public Criteria andOperatorIdLessThan(Long value) {
            addCriterion("operator_id <", value, "operatorId");
            return (Criteria) this;
        }

        public Criteria andOperatorIdLessThanOrEqualTo(Long value) {
            addCriterion("operator_id <=", value, "operatorId");
            return (Criteria) this;
        }

        public Criteria andOperatorIdIn(List<Long> values) {
            addCriterion("operator_id in", values, "operatorId");
            return (Criteria) this;
        }

        public Criteria andOperatorIdNotIn(List<Long> values) {
            addCriterion("operator_id not in", values, "operatorId");
            return (Criteria) this;
        }

        public Criteria andOperatorIdBetween(Long value1, Long value2) {
            addCriterion("operator_id between", value1, value2, "operatorId");
            return (Criteria) this;
        }

        public Criteria andOperatorIdNotBetween(Long value1, Long value2) {
            addCriterion("operator_id not between", value1, value2, "operatorId");
            return (Criteria) this;
        }

        public Criteria andOperatorNameIsNull() {
            addCriterion("operator_name is null");
            return (Criteria) this;
        }

        public Criteria andOperatorNameIsNotNull() {
            addCriterion("operator_name is not null");
            return (Criteria) this;
        }

        public Criteria andOperatorNameEqualTo(String value) {
            addCriterion("operator_name =", value, "operatorName");
            return (Criteria) this;
        }

        public Criteria andOperatorNameNotEqualTo(String value) {
            addCriterion("operator_name <>", value, "operatorName");
            return (Criteria) this;
        }

        public Criteria andOperatorNameGreaterThan(String value) {
            addCriterion("operator_name >", value, "operatorName");
            return (Criteria) this;
        }

        public Criteria andOperatorNameGreaterThanOrEqualTo(String value) {
            addCriterion("operator_name >=", value, "operatorName");
            return (Criteria) this;
        }

        public Criteria andOperatorNameLessThan(String value) {
            addCriterion("operator_name <", value, "operatorName");
            return (Criteria) this;
        }

        public Criteria andOperatorNameLessThanOrEqualTo(String value) {
            addCriterion("operator_name <=", value, "operatorName");
            return (Criteria) this;
        }

        public Criteria andOperatorNameLike(String value) {
            addCriterion("operator_name like", value, "operatorName");
            return (Criteria) this;
        }

        public Criteria andOperatorNameNotLike(String value) {
            addCriterion("operator_name not like", value, "operatorName");
            return (Criteria) this;
        }

        public Criteria andOperatorNameIn(List<String> values) {
            addCriterion("operator_name in", values, "operatorName");
            return (Criteria) this;
        }

        public Criteria andOperatorNameNotIn(List<String> values) {
            addCriterion("operator_name not in", values, "operatorName");
            return (Criteria) this;
        }

        public Criteria andOperatorNameBetween(String value1, String value2) {
            addCriterion("operator_name between", value1, value2, "operatorName");
            return (Criteria) this;
        }

        public Criteria andOperatorNameNotBetween(String value1, String value2) {
            addCriterion("operator_name not between", value1, value2, "operatorName");
            return (Criteria) this;
        }

        public Criteria andExt1IsNull() {
            addCriterion("ext_1 is null");
            return (Criteria) this;
        }

        public Criteria andExt1IsNotNull() {
            addCriterion("ext_1 is not null");
            return (Criteria) this;
        }

        public Criteria andExt1EqualTo(String value) {
            addCriterion("ext_1 =", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotEqualTo(String value) {
            addCriterion("ext_1 <>", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1GreaterThan(String value) {
            addCriterion("ext_1 >", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1GreaterThanOrEqualTo(String value) {
            addCriterion("ext_1 >=", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1LessThan(String value) {
            addCriterion("ext_1 <", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1LessThanOrEqualTo(String value) {
            addCriterion("ext_1 <=", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1Like(String value) {
            addCriterion("ext_1 like", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotLike(String value) {
            addCriterion("ext_1 not like", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1In(List<String> values) {
            addCriterion("ext_1 in", values, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotIn(List<String> values) {
            addCriterion("ext_1 not in", values, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1Between(String value1, String value2) {
            addCriterion("ext_1 between", value1, value2, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotBetween(String value1, String value2) {
            addCriterion("ext_1 not between", value1, value2, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt2IsNull() {
            addCriterion("ext_2 is null");
            return (Criteria) this;
        }

        public Criteria andExt2IsNotNull() {
            addCriterion("ext_2 is not null");
            return (Criteria) this;
        }

        public Criteria andExt2EqualTo(String value) {
            addCriterion("ext_2 =", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotEqualTo(String value) {
            addCriterion("ext_2 <>", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2GreaterThan(String value) {
            addCriterion("ext_2 >", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2GreaterThanOrEqualTo(String value) {
            addCriterion("ext_2 >=", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2LessThan(String value) {
            addCriterion("ext_2 <", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2LessThanOrEqualTo(String value) {
            addCriterion("ext_2 <=", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2Like(String value) {
            addCriterion("ext_2 like", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotLike(String value) {
            addCriterion("ext_2 not like", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2In(List<String> values) {
            addCriterion("ext_2 in", values, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotIn(List<String> values) {
            addCriterion("ext_2 not in", values, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2Between(String value1, String value2) {
            addCriterion("ext_2 between", value1, value2, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotBetween(String value1, String value2) {
            addCriterion("ext_2 not between", value1, value2, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt3IsNull() {
            addCriterion("ext_3 is null");
            return (Criteria) this;
        }

        public Criteria andExt3IsNotNull() {
            addCriterion("ext_3 is not null");
            return (Criteria) this;
        }

        public Criteria andExt3EqualTo(String value) {
            addCriterion("ext_3 =", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotEqualTo(String value) {
            addCriterion("ext_3 <>", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3GreaterThan(String value) {
            addCriterion("ext_3 >", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3GreaterThanOrEqualTo(String value) {
            addCriterion("ext_3 >=", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3LessThan(String value) {
            addCriterion("ext_3 <", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3LessThanOrEqualTo(String value) {
            addCriterion("ext_3 <=", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3Like(String value) {
            addCriterion("ext_3 like", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotLike(String value) {
            addCriterion("ext_3 not like", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3In(List<String> values) {
            addCriterion("ext_3 in", values, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotIn(List<String> values) {
            addCriterion("ext_3 not in", values, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3Between(String value1, String value2) {
            addCriterion("ext_3 between", value1, value2, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotBetween(String value1, String value2) {
            addCriterion("ext_3 not between", value1, value2, "ext3");
            return (Criteria) this;
        }
    }

    /**
     */
    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}